package com.winhc.bigdata.spark.test

import java.util
import java.util.Properties

import com.winhc.bigdata.spark.utils.{PhoenixUtil, SparkUtils}
import org.apache.spark.sql.Row
import org.apache.spark.sql.types.{DataType, StringType, StructField, StructType, UserDefinedType, VarcharType}

import scala.collection.mutable

/**
 * @Author: XuJiakai
 * @Date: 2020/6/3 15:53
 * @Description:
 */
object TestSpark2PhoenixJDBC {
  def main(args: Array[String]): Unit = {
    val map = mutable.Map[String, String](
      "spark.hadoop.odps.spark.local.partition.amt" -> "100"
    )
    val sparkSession = SparkUtils.InitEnv("scala spark on Phoenix5.x test", map)
    val DB_PHOENIX_URL = PhoenixUtil.getPhoenixJDBCUrl

    // JDBC连接属性
    val SQL_QUERY = " ( SELECT ID,NCID,CID,TITLE FROM COMPANY_BID_LIST limit 10 )  events  "
    val connProp = PhoenixUtil.getPhoenixProperties
    val pDf = sparkSession.read.jdbc(DB_PHOENIX_URL, SQL_QUERY, connProp)
    val sc = pDf.schema
    println(sc)
    pDf.printSchema()
    pDf.show()
    import sparkSession.implicits._
    import sparkSession._

    var dt:DataType = VarcharType(255)
//    dt = StringType
    val schema = StructType(Array(
      StructField("k", dt, nullable = false),
      StructField("s", dt, nullable = true),
      StructField("time", dt, nullable = true)
    )
    )
    val dataList = new util.ArrayList[Row]()
    dataList.add(Row("1", "2", "null"))
    val df = createDataFrame(dataList, schema)

    df.write
      .mode("append")
      .jdbc(DB_PHOENIX_URL, "TEST_P", connProp)

    sparkSession.stop()
  }
}
